//#include "MDMA.h"
#include "CGUInit.h"
#include "DMCInit.h"

#define SOURCE_PSIZE 8
#define DEST_PSIZE  8
#define SOURCE_MSIZE 32
#define DEST_MSIZE   32
#define SOURCE_DMA_CFG	ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_PSIZE04
#define DEST_DMA_CFG 	BITM_DMA_CFG_WNR|ENUM_DMA_CFG_PSIZE04|ENUM_DMA_CFG_MSIZE32|ENUM_DMA_CFG_XCNT_INT

#define MAX_SIZE 8*1024

#define CCLK_SPEED 450
#define SCLK_SPEED 112.5

#define DMC0_BANK0_START_ADDRESS 0x80000000
#define DMC0_BANK1_START_ADDRESS 0x81000000

#define DMC_CTL_VALUE 		0x00000405
#define DMC_CFG_VALUE 		0x00000522
#define DMC_TR0_VALUE 		0x41711646
#define DMC_TR1_VALUE 		0x40480DB6
#define DMC_TR2_VALUE 		0x00347417
#define DMC_MR0_VALUE		0x00000730
#define DMC_MR1_VALUE 		0x00000006
#define DMC_MR2_VALUE 		0x00000008
#define DMC_PADCTL2_VALUE 	0x0078283C
#define DMC_CPHYCTL_VALUE   0x0000001A
#define DMC0_DATA_CALIB_ADD 0x80000000
#define DMC1_DATA_CALIB_ADD 0xC0000000

#define MDMA_CONFIG(S_MDMA_CHANNEL,S_CFG, S_ADDRSTART, S_MOD, S_COUNT,D_MDMA_CHANNEL,D_CFG, D_ADDRSTART, D_MOD, D_COUNT)\
		*pREG_DMA##S_MDMA_CHANNEL##_CFG = S_CFG;\
		*pREG_DMA##S_MDMA_CHANNEL##_ADDRSTART = S_ADDRSTART;\
		*pREG_DMA##S_MDMA_CHANNEL##_XCNT = S_COUNT;\
		*pREG_DMA##S_MDMA_CHANNEL##_XMOD = S_MOD;\
		*pREG_DMA##D_MDMA_CHANNEL##_CFG = D_CFG;\
		*pREG_DMA##D_MDMA_CHANNEL##_ADDRSTART = D_ADDRSTART;\
		*pREG_DMA##D_MDMA_CHANNEL##_XCNT = D_COUNT;\
		*pREG_DMA##D_MDMA_CHANNEL##_XMOD = D_MOD;

#define WAIT_FOR_DMADONE(DMA_CHANNEL)\
		while(!(*pREG_DMA##DMA_CHANNEL##_STAT & ENUM_DMA_STAT_IRQDONE));

//Macro to disable the MDMA
#define DISABLE_DMAs(S_MDMA_CHANNEL, D_MDMA_CHANNEL)\

void CGUInit(void);
